<?php

require 'vendor/autoload.php';

use GabrielGciaFdez\Entity\EmailData;
use Symfony\Component\Validator\Validation;
use Doctrine\Common\Annotations\AnnotationRegistry;

// mock data
$data = json_decode('{
    "userHash": "18a98c35f49808b45edadc75fb1b25ebfd4037d6",
    "sender": "hi@gabi.cat",
    "subject": "Validation rocks!",
    "recipients": [
        {
            "name": "John Doe",
            "email": "jdoe@email.com"
        },
        {
            "email": "other@email.com",
            "name": null
        }
    ],
    "date": "2014-05-01 12:11:11",
    "hasLinks": true,
    "numOfLinks": 2
}
', true);

if ($data === null) {
    die("data is null");
}

$entity = new EmailData($data);

// Doctrine don't use autoload PHP, we must register it manually
AnnotationRegistry::registerAutoloadNamespace("Symfony\Component\Validator\Constraint", "vendor/symfony/validator");
AnnotationRegistry::registerAutoloadNamespace("GabrielGciaFdez\Validator\Constraint", "src/");

$validator = Validation::createValidatorBuilder()
    ->enableAnnotationMapping()
    ->getValidator();

$errors = $validator->validate($entity);

if (count($errors) === 0) {
    echo "OK";
    return;
}

echo $errors;